VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmList 
   Caption         =   "List"
   ClientHeight    =   8505
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8055
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   8505
   ScaleMode       =   0  'User
   ScaleWidth      =   8055
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox Picture1 
      Align           =   2  'Align Bottom
      Appearance      =   0  'Flat
      BackColor       =   &H80000004&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   0
      ScaleHeight     =   615
      ScaleWidth      =   8055
      TabIndex        =   3
      Top             =   7890
      Width           =   8055
      Begin VB.CommandButton cmdCancel 
         Caption         =   "Close"
         Height          =   375
         Left            =   5400
         TabIndex        =   5
         Top             =   120
         Width           =   1095
      End
      Begin VB.CommandButton cmdMore 
         Caption         =   "More"
         Height          =   375
         Left            =   3120
         TabIndex        =   4
         Top             =   120
         Width           =   1095
      End
   End
   Begin VB.Frame Frame1 
      Height          =   5175
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   7455
      Begin VB.TextBox txtSendQuery 
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   360
         Width           =   7215
      End
      Begin MSComctlLib.ListView ListView1 
         Height          =   3375
         Left            =   120
         TabIndex        =   2
         TabStop         =   0   'False
         Top             =   1320
         Width           =   7215
         _ExtentX        =   12726
         _ExtentY        =   5953
         View            =   3
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   0
      End
      Begin VB.Label lblRecords 
         Caption         =   "nnnn records found"
         Height          =   255
         Left            =   2640
         TabIndex        =   1
         Top             =   4800
         Width           =   1695
      End
   End
End
Attribute VB_Name = "frmList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim maxrows As Integer ' max number of rows to fetch in one chunk(100)
Dim morebuttonrequested As Boolean
Dim numrows As Long ' how many rows do we have in the grid now
Dim numcols As Integer ' how many columns
Dim rowcount As Long
Dim ColWidths() As Long ' max width of each column
Dim ColTotals() As Double ' total of (numeric) columns
Dim IDs() As String ' array of object IDs
Dim IdCol As Integer ' which column has the ID ?
Private quiet As Boolean ' don't react while loading
Private FullFileName As Integer ' column 'FullFileName' if any (see ListView1_Click)
Private Sub Form_Activate()
    Set result = Cache.ResultSet(HiClass, HiQuery)
    result.Execute SendQuery
    maxrows = 100
    morebuttonrequested = True
    numrows = 0
    quiet = True
    txtSendQuery = SendQuery
    Frame1.Visible = False
    LoadGridHeaders
    LoadGrid
    quiet = False
    Frame1.Visible = True
    rowcount = ListView1.ListItems.count
    ' set non-default listview properties
    With ListView1
        .FullRowSelect = True
    End With
    If rowcount = 0 Then
        MsgBox "No Matching Records Found"
        Unload Me
    End If
End Sub
Private Sub Form_Unload(Cancel As Integer)
    If Not result Is Nothing Then result.Close
    Set result = Nothing
End Sub
Private Sub LoadGridHeaders()
    ' load column headers for grid based on query
    
    ListView1.Columnheaders.Clear
    ListView1.ListItems.Clear
    
    numcols = result.GetColumnCount
    ReDim ColWidths(numcols) As Long
    ReDim ColTotals(numcols) As Double
    
    IdCol = result.ContainsID ' which column has ID, if any
    
    ' Set up columns
    Dim col As Integer ' index to Colwidths and Grid
    Dim rescol As Integer ' index to Getdata
    Dim colhdr As String
    col = 0
    FullFileName = 0
    For rescol = 1 To numcols
        If rescol <> IdCol Then
            col = col + 1
            colhdr = result.GetColumnHeader(rescol)
            ColWidths(col) = Me.TextWidth(colhdr)
            ListView1.Columnheaders.Add , , colhdr, ColWidths(col)
            If col > 1 Then ListView1.Columnheaders.Item(col).Alignment = lvwColumnCenter
            If colhdr = "FullFileName" Then FullFileName = col
        End If
    Next rescol
    
End Sub
Private Sub LoadGrid()

Dim itemcount As Long, i As Integer
Dim moretofetch As Boolean ' more rows to fetch ?
    
    Screen.MousePointer = vbHourglass
    
    ' if numrows=0 then this is the first time
    If numrows = 0 Then
        ListView1.ListItems.Clear
        For i = 1 To numcols
            ColTotals(i) = 0
        Next i
        numrows = maxrows
        ReDim IDs(numrows) As String
        itemcount = 0
        
    ' else it is a subsequent call - note that the first record of this chunk
    '  has aleady been 'read'
    Else
        numrows = numrows + maxrows
        ReDim Preserve IDs(numrows) As String
        itemcount = 1
        AddItem
    End If
    
    moretofetch = True
    For itemcount = itemcount + 1 To maxrows
        If result.Next Then
            AddItem
        Else
            moretofetch = False
            Exit For
        End If
    Next itemcount
    If moretofetch And Not result.Next Then moretofetch = False ' probe one record forward
    
    ' display record count
    If moretofetch Then
        lblRecords = ">" & ListView1.ListItems.count & " records found"
    Else
        ' break it down for language translation !
        If ListView1.ListItems.count = 0 Then
            lblRecords = "No records found"
        ElseIf ListView1.ListItems.count = 1 Then
            lblRecords = "1 record found"
        Else
            lblRecords = ListView1.ListItems.count & " records found"
        End If
    End If
    
    ' display totals (if any)
    If Not moretofetch Then DisplayTotals
        
    ' deselect all
    Set ListView1.SelectedItem = Nothing
    
    ' display More button if requested
    If moretofetch And morebuttonrequested Then
        cmdMore.Visible = True
    Else
        cmdMore.Visible = False
    End If
        
    Screen.MousePointer = vbDefault
    
End Sub
Private Sub AddItem()
    ' read data from query; store id's in data slot
    
    Dim Item As ListItem
    Dim colvalue As String
    Dim colwidth As Long
    Dim rescol As Integer ' index to Getdata()
    Dim col As Integer ' index to Grid()
    
    
    ' Very confusing numbering (e.g.) :
    '                       ID      Name    Sex     DOB     SSN
    '   GetData(rescol)      1        2      3       4       5
    '   col                           1      2       3       4
    '   index (of item)               1      2       3       4
    '   subitem                              1       2       3
    ' Or
    '                       Name     Sex    ID     DOB     SSN
    '   GetData(rescol)      1        2      3       4       5
    '   col                  1        2              3       4
    '   index (of item)      1        2              3       4
    '   subitem                       1              2       3
    
    
    Set Item = ListView1.ListItems.Add
        
    If IdCol Then
        IDs(ListView1.ListItems.count) = result.GetData(IdCol) ' save ID for later
    End If
    
    col = 0
    For rescol = 1 To numcols
        If rescol <> IdCol Then
            col = col + 1
            colvalue = result.GetData(rescol)
            colwidth = Me.TextWidth(colvalue)
            If colwidth < 900 Then colwidth = 900 ' min 900 pixels
            If colwidth > 1500 Then colwidth = 1500 ' max 30 chars
            If colwidth > ColWidths(col) Then
                ColWidths(col) = colwidth
                ListView1.Columnheaders.Item(col).Width = colwidth
            End If
        
            ' strip leading "$" if any
            ' (cheat : omit if col header = "Age")
            Dim temp As String
            temp = colvalue
            If Left(temp, 1) = "$" Then
                temp = Mid(colvalue, 2)
                ListView1.Columnheaders.Item(col).Alignment = lvwColumnRight
            End If
            If result.GetColumnHeader(rescol) = "Age" Then temp = ""
            ' add to totals, if numeric
            If IsNumeric(temp) Then ColTotals(col) = ColTotals(col) + Val(temp)
            
            ' first field goes into .Text
            If col = 1 Then
                Item.text = colvalue
            ' rest into .SubItems
            Else
                Item.SubItems(col - 1) = colvalue
            End If
            
        End If
    Next rescol

End Sub
Private Sub DisplayTotals()
    Dim Item As ListItem
    Dim displaythem As Boolean
    Dim rescol As Integer
    Dim col As Integer
    Dim colvalue As String
    Dim colwidth As Long
    
    For rescol = 1 To numcols
            If ColTotals(rescol) <> 0 Then displaythem = True
    Next rescol
    
    If Not displaythem Then Exit Sub
    
    Set Item = ListView1.ListItems.Add
    col = 0
    For rescol = 1 To numcols
        If rescol <> IdCol Then
            col = col + 1
            ' first column is fixed as "Total"
            If col = 1 Then
                colvalue = "Totals"
            Else
                colvalue = ColTotals(col)
                If colvalue = "0" Then colvalue = ""
            End If
            colwidth = Me.TextWidth(colvalue)
            If colwidth < 900 Then colwidth = 900 ' min 900 pixels
            If colwidth > 1500 Then colwidth = 1500 ' max 30 chars
            If colwidth > ColWidths(col) Then
                ColWidths(col) = colwidth
                ListView1.Columnheaders.Item(col).Width = colwidth
            End If
        
            If col = 1 Then
                Item.text = colvalue
            Else
                Item.SubItems(col - 1) = colvalue
            End If
            
        End If
    Next rescol
End Sub
Private Sub AdjustSizes()
    ' subroutine to adjust the format of the lookup according to the data
    '  and the size of the form
    
    On Error Resume Next ' in case anything goes negative
    
    ' First the heights.
    '  The form is made up of
    '     - a gap (frame1.top)
    '     - the frame
    '     - a gap (= frame1.top)
    '     - the picture (bottom-aligned) for the buttons (picture1.height)
    ' Adjust the frame height to match the space left
    Frame1.Height = Me.ScaleHeight - Frame1.Top - Frame1.Top - Picture1.Height
    
    ' Inside the frame:
    '    - a gap (100)
    '    - the query
    '    - a gap (100)
    '    - the grid
    '    - a gap (100)
    '    - lblRecords
    '    - a gap (100)
    ' Adjust the grid height to match the space left
    txtSendQuery.Top = 100
    ListView1.Top = 100 + txtSendQuery.Height + 100
    ListView1.Height = Frame1.Height - 100 - txtSendQuery.Height - 100 - 100 - lblRecords.Height - 100
    ' Move the lblRecords into place
    lblRecords.Top = ListView1.Top + ListView1.Height + 100
        
    ' Now the widths
    '  First the picture, containing
    '     - a gap
    '     - the more button, if requested and needed
    '     - a gap (if more button present)
    '     - the cancel button
    '     - a gap
    ' Adjust the button spacing to match the space left
    Dim buttonswidth As Long, buttongap As Long
    buttonswidth = cmdCancel.Width
    If cmdMore.Visible Then
        buttonswidth = buttonswidth + cmdMore.Width
        buttongap = (Me.ScaleWidth - buttonswidth) / 3
    Else
        buttongap = (Me.ScaleWidth - buttonswidth) / 2
    End If
    If cmdMore.Visible Then
        cmdMore.Left = buttongap
        cmdCancel.Left = cmdMore.Left + cmdMore.Width + buttongap
    Else
        cmdCancel.Left = buttongap
    End If
    
    '  The form is made up of
    '     - a gap (frame1.left)
    '     - the frame
    '     - a gap (=frame1.left)
    ' Adjust the frame width
    Frame1.Width = Me.ScaleWidth - Frame1.Left - Frame1.Left
    
    ' Within the frame, we have
    '   - a gap (100)
    '   - the sendquery/listview/lblRecords (viewwidth)
    '   - a gap (100)
    Dim viewwidth As Long
    viewwidth = Frame1.Width - 100 - 100
    
    ' Adjust the listview and sendquery
    ListView1.Width = viewwidth
    txtSendQuery.Width = viewwidth
    ' Adjust the lblRecords location
    lblRecords.Left = (Frame1.Width - lblRecords.Width) / 2
    
    On Error GoTo 0
End Sub
Private Sub cmdMore_Click()
    LoadGrid
End Sub
Private Sub cmdCancel_Click()
    Unload frmShowDetails
    Unload Me
End Sub
Private Sub Form_Resize()
    AdjustSizes
End Sub
Private Sub ListView1_Click()
    Dim File As String
    If ListView1.SelectedItem Is Nothing Then Exit Sub
    ' if the query has a column named 'FullFileName', then execute this
    If FullFileName Then
        File = ListView1.SelectedItem.ListSubItems(FullFileName - 1)
        HyperindexUtils.RunFile (File)
    Else
        Set Columnheaders = ListView1.Columnheaders
        Set SelectedItem = ListView1.SelectedItem
        frmShowDetails.Show
    End If
End Sub

