VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmDrillDown 
   Caption         =   "Drill Down"
   ClientHeight    =   6480
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10140
   LinkTopic       =   "Form1"
   ScaleHeight     =   6480
   ScaleWidth      =   10140
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdAbort 
      Caption         =   "Abort"
      Height          =   375
      Left            =   8640
      TabIndex        =   10
      Top             =   1200
      Width           =   1215
   End
   Begin VB.ComboBox cboTotal 
      Height          =   315
      ItemData        =   "DrillDown.frx":0000
      Left            =   1200
      List            =   "DrillDown.frx":000D
      TabIndex        =   8
      Text            =   "Total"
      Top             =   600
      Width           =   1110
   End
   Begin MSComctlLib.ListView lvwTotals 
      Height          =   4575
      Left            =   120
      TabIndex        =   7
      Top             =   1680
      Width           =   9615
      _ExtentX        =   16960
      _ExtentY        =   8070
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.ComboBox cboCols 
      Height          =   315
      Left            =   4440
      TabIndex        =   5
      Top             =   1320
      Width           =   3015
   End
   Begin VB.ComboBox cboBitSlice 
      Height          =   315
      Left            =   2400
      TabIndex        =   4
      Top             =   600
      Width           =   2415
   End
   Begin VB.ComboBox cboRows 
      Height          =   315
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   3255
   End
   Begin VB.TextBox txtQuery 
      Height          =   375
      Left            =   1200
      TabIndex        =   0
      Top             =   120
      Width           =   8655
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Report :"
      Height          =   375
      Left            =   240
      TabIndex        =   9
      Top             =   600
      Width           =   855
   End
   Begin VB.Label Label4 
      Caption         =   "Cols"
      Height          =   195
      Left            =   4800
      TabIndex        =   6
      Top             =   1080
      Width           =   735
   End
   Begin VB.Label Label3 
      Caption         =   "Rows"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   735
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "ResultSet :"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   200
      Width           =   855
   End
End
Attribute VB_Name = "frmDrillDown"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim qhandle As String
Dim category1 As String, categoryid1 As Long
Dim category2 As String, categoryid2 As Long
Dim bitsliceid As Long, tcount As Long, ttotal As Double, tscale As Integer
Dim displaying As Integer, abort As Integer
Private Sub Form_Activate()
    cmdAbort.Enabled = False
    lvwTotals.View = lvwReport
    ' show query
    txtQuery = CacheQuery
    ' Rerun query to get the qhandle
    HiStatic.HiQueryExecute qhandle, SendQuery
    category1 = ""
    categoryid1 = 0
    category2 = ""
    categoryid2 = 0
    bitsliceid = cboBitSlice.ItemData(cboBitSlice.ListIndex)
    tcount = HiStatic.HiQueryCount(qhandle)
    ttotal = HyperindexUtils.Sum(HiClass, qhandle, bitsliceid, tscale)
    DisplayIt
    cboRows.SetFocus
End Sub
Private Sub cboTotal_Click()
    If qhandle = "" Then Exit Sub ' when called from frmMain
    If displaying Then Exit Sub ' disable events until display finished/aborted
    DisplayIt
End Sub
Private Sub cboBitSlice_Click()
    If qhandle = "" Then Exit Sub ' when called from frmMain
    If displaying Then Exit Sub ' disable events until display finished/aborted
    bitsliceid = cboBitSlice.ItemData(cboBitSlice.ListIndex)
    ttotal = HyperindexUtils.Sum(HiClass, qhandle, bitsliceid, tscale)
    DisplayIt
End Sub
Private Sub cboRows_Click()
    If displaying Then Exit Sub ' disable events until display finished/aborted
    category1 = cboRows
    categoryid1 = cboRows.ItemData(cboRows.ListIndex)
    DisplayIt
End Sub
Private Sub cboCols_Click()
    If displaying Then Exit Sub ' disable events until display finished/aborted
    category2 = cboCols
    categoryid2 = cboCols.ItemData(cboCols.ListIndex)
    DisplayIt
End Sub
Private Sub DisplayIt()
    ' There are 5 options here:
    '  1. neither Row nor Col selected - just display total
    '  2. Row Selected - display 2-column table
    '  3. Col Selected - display 2-row table
    '  4. Both Row and Col Selected (and different) - display full table
    '  5. Both Row and Col Selected (but same) - do nothing
    
    Dim conditionid As Long, conditionid2 As Long
    Dim result As Object, result2 As Object
    Dim i As Integer, col As Integer
    Dim item As ListItem, total As Double, tformat As String
    Dim lcount As Long
    ' these are in case the user changes the controls during the display
    Dim totalorave As String, bitslice As String
    
    abort = 0
    cmdAbort.Enabled = True
    displaying = 1
    totalorave = cboTotal
    bitslice = cboBitSlice
    
    lvwTotals.Columnheaders.Clear
    lvwTotals.ListItems.Clear
    
    If categoryid1 = 0 And categoryid2 = 0 Then
        ' Load Total value into Listview
        lvwTotals.Columnheaders.Add , , totalorave
        tformat = "#,##0"
        If tscale > 0 Then
            tformat = tformat + "."
            For i = 1 To tscale
                tformat = tformat + "0"
            Next i
        End If
        Set item = lvwTotals.ListItems.Add
        If totalorave = "Total" Then
            item.text = Format(ttotal, tformat)
        ElseIf tcount = 0 Then
            item.text = ""
        ElseIf totalorave = "Count" Then
            item.text = tcount
        Else
            item.text = Format(ttotal / tcount, tformat)
        End If
        displaying = 0
        cmdAbort.Enabled = False
        Exit Sub
    End If
    
    If categoryid2 = 0 Then
        ' Load values of category1 into col 1, totals in col 2
        lvwTotals.Columnheaders.Add , , category1
        lvwTotals.Columnheaders.Add , , totalorave + " " + bitslice, , lvwColumnRight
    
        Set result = Cache.ResultSet("Hi.Condition", "AllConditions")
        result.Execute HiClass, categoryid1
        While result.Next And abort = 0
            Set item = lvwTotals.ListItems.Add
            conditionid = result.GetData(1)
            item.text = result.GetData(4)
            ' get and display the total for the condition
            total = HyperindexUtils.Sum1(HiClass, qhandle, conditionid, bitsliceid, tscale, lcount)
            If totalorave = "Average" Then
                If lcount = 0 Then
                    total = 0
                Else
                    total = total / lcount
                End If
            End If
            tformat = "#,##0"
            If tscale > 0 Then
                tformat = tformat + "."
                For i = 1 To tscale
                    tformat = tformat + "0"
                Next i
            End If
            If totalorave = "Count" Then
                item.SubItems(1) = lcount
            Else
                item.SubItems(1) = Format(total, tformat)
            End If
            DoEvents
        Wend
        result.Close
        displaying = 0
        cmdAbort.Enabled = False
        Exit Sub
    End If
    
    If categoryid1 = 0 Then
        ' Load values of category2 into headers, totals in row 2
        lvwTotals.Columnheaders.Add , , category2
    
        Set result = Cache.ResultSet("Hi.Condition", "AllConditions")
        result.Execute HiClass, categoryid2
        While result.Next And abort = 0
            lvwTotals.Columnheaders.Add , , result.GetData(4)
        Wend
        result.Close
        
        Set item = lvwTotals.ListItems.Add
        item.text = totalorave + " " + bitslice
        result.Execute HiClass, categoryid2, ""
        col = 0
        While result.Next And abort = 0
            conditionid = result.GetData(1)
            ' get and display the total for the condition
            total = HyperindexUtils.Sum1(HiClass, qhandle, conditionid, bitsliceid, tscale, lcount)
            If totalorave = "Average" Then
                If lcount = 0 Then
                    total = 0
                Else
                    total = total / lcount
                End If
            End If
            tformat = "#,##0"
            If tscale > 0 Then
                tformat = tformat + "."
                For i = 1 To tscale
                    tformat = tformat + "0"
                Next i
            End If
            col = col + 1
            If totalorave = "Count" Then
                item.SubItems(col) = lcount
            Else
                item.SubItems(col) = Format(total, tformat)
            End If
            DoEvents
        Wend
        result.Close
        displaying = 0
        cmdAbort.Enabled = False
        Exit Sub
    End If
    
    If categoryid1 = categoryid2 Then
        displaying = 0
        cmdAbort.Enabled = False
        Exit Sub
    End If
    
    ' Load values of category2 into header, values of category 1 and totals into rows
    lvwTotals.Columnheaders.Add , , category1 + "\" + category2

    Set result = Cache.ResultSet("Hi.Condition", "AllConditions")
    result.Execute HiClass, categoryid2
    While result.Next And abort = 0
        lvwTotals.Columnheaders.Add , , result.GetData(4), , lvwColumnRight
    Wend
    result.Close
    
    Set result = Cache.ResultSet("Hi.Condition", "AllConditions")
    Set result2 = Cache.ResultSet("Hi.Condition", "AllConditions")
    ' loop for each row
    result.Execute HiClass, categoryid1
    While result.Next And abort = 0
        conditionid = result.GetData(1)
        col = 0
        Set item = lvwTotals.ListItems.Add
        item.text = result.GetData(4)
        ' loop for each column
        result2.Execute HiClass, categoryid2
        While result2.Next And abort = 0
            conditionid2 = result2.GetData(1)
            total = HyperindexUtils.Sum2(HiClass, qhandle, conditionid, conditionid2, bitsliceid, tscale, lcount)
            If totalorave = "Average" Then
                If lcount = 0 Then
                    total = 0
                Else
                    total = total / lcount
                End If
            End If
            tformat = "#,##0"
            If tscale > 0 Then
                tformat = tformat + "."
                For i = 1 To tscale
                    tformat = tformat + "0"
                Next i
            End If
            col = col + 1
            If totalorave = "Count" Then
                item.SubItems(col) = lcount
            Else
                item.SubItems(col) = Format(total, tformat)
            End If
            DoEvents
        Wend
        result2.Close
    Wend
    result.Close
    displaying = 0
    cmdAbort.Enabled = False
End Sub
Private Sub Form_Deactivate()
    ' Release the qhandle row
    HiStatic.HiQueryClose qhandle
    displaying = 0
    cmdAbort.Enabled = False
End Sub
Private Sub cmdAbort_Click()
    abort = 1
    cmdAbort.Enabled = False
End Sub
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    qhandle = "" ' disable events in frmDrillDown
End Sub
